<template>
  <Menu ref="menu"/>
  <div id="wrapper" class="wrapper">
    <NavBar id="navbar"/>
    <div class="content-wrapper">
      <component :is="currentComponent"/>
    </div>
    <Footer/>
  </div>
</template>

<script>
import NavBar from './components/NavBar.vue'
import Menu from './components/Menu.vue'
import Landing from '@/pages/landing/Landing.vue'
import News from "@/pages/news/News.vue";
import Exchanges from "@/pages/exchanges/Exchanges.vue";
import CryptoCurrencies from "@/pages/cryptocurrencies/CryptoCurrencies.vue";
import Payment from '@/pages/payment/Payment.vue';
import Settings from "@/pages/settings/Settings.vue";
import ServerStats from '@/pages/server_stats/ServerStats.vue'
import AboutUs from "@/pages/about_us/AboutUs.vue";
import Footer from './components/Footer.vue'
import Trading from "@/pages/trading/Trading.vue";
import Portfolio from "@/pages/portfolio/Portfolio.vue";

export default {
  name: 'App',
  components: {
    NavBar,
    Menu,
    Landing,
    News,
    Exchanges,
    CryptoCurrencies,
    Payment,
    Trading,
    Portfolio,
    Settings,
    ServerStats,
    AboutUs,
    Footer
  },
  data() {
    return {
      currentComponent: 'Landing',
      theme_link: document.createElement('link')
    };
  },
  provide() {
    return {
      App: this
    }
  },
  methods: {
    updateNavBarHeight() {
      const navbar = document.getElementById('navbar');
      const navbarHeight = navbar.clientHeight;
      document.getElementById('wrapper').style.paddingTop = `${navbarHeight}px`;
    }
  },
  mounted() {
    this.updateNavBarHeight();
    window.onresize = this.updateNavBarHeight;

    const showMenuButton = document.getElementById('show-menu-button');
    showMenuButton.addEventListener('click', () => {
      this.$refs.menu.onShowClick();
    });
    window.dispatchEvent(new Event('resize'));

    this.theme_link.rel = 'stylesheet';
    this.theme_link.href = '/assets/styles/themes/default_theme.css';
    document.head.appendChild(this.theme_link);
  },
}

</script>

<style lang="scss">
@import '~bootstrap/scss/bootstrap';
@import '@fortawesome/fontawesome-free/css/all.css';

@import "../public/assets/styles/themes/default_theme.css";

.default-button {
  @extend .btn;
  border: none;
  border-radius: var(--bs-border-radius);
  background-color: var(--white-color);
  font-size: 1.25rem;
  color: var(--primary-color);
}

button {
  @extend .btn-primary;
  @extend .default-button;
}
</style>

<style>
#app {
  font-family: "KTF",sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  background-color: var(--background-color);
  color: var(--text-color);
}

h1 {
  margin: 3rem 0 1rem;
  font-size: 3rem;
  padding-bottom: 2rem;
  border-bottom: 1px solid var(--light-color);
}

.wrapper {
  display: flex;
  flex-direction: column;
  min-height: 100vh;
}

.content-wrapper {
  display: flex;
  flex: 1;
  flex-direction: column;
}

</style>
